<?php
namespace Freshmail;

use Freshmail\Init;
use Freshmail\Core\DocHooks;

if (!function_exists('Freshmail\\freshmailDoc')) {
  function freshmailDoc()
  {
    return DocHooks::get();
  }
}

if (!function_exists('Freshmail\\freshmail')) {
  function freshmail($moduleName = '')
  {
    $modules = Init::get();
    if ('' === $moduleName) {
      return $modules;
    }
    if (!array_key_exists($moduleName, $modules->public)) {
      throw new \Exception(sprintf(__('Module %1$s doesn\'t exists!', 'freshmail'), $moduleName));
    }
    return $modules->public[$moduleName];
  }
}

if (!function_exists('Freshmail\\createClass')) {
  /**
   * Create instance of Class
   *
   * @see https://gist.github.com/nikic/6390366
   *
   * @param string $class
   * @param array $params
   * @return object
   */
  function createClass($class, $params = array())
  {
    $object = new $class(...$params);
    freshmailDoc()->addDocHooks($object);
    return $object;
  }
}
